<xsl:stylesheet version = '1.0' xmlns:xsl='http://www.w3.org/1999/XSL/Transform'>

<xsl:variable name="total_hosts">
    <xsl:value-of select="count(/bininfo/hosts/host_stat)"/>
</xsl:variable>

<xsl:template match="/bininfo">
     <xsl:choose>
         <xsl:when test="//error">
              <HTML><HEAD><TITLE>Statistics for bin</TITLE></HEAD>
              <BODY>
                  <H4>Error: <xsl:value-of select="error"/></H4>
                  <HR/>
              </BODY></HTML>
         </xsl:when>
         <xsl:otherwise>
             <HTML><HEAD><TITLE>Statistics for <xsl:value-of select="sourcebin"/></TITLE></HEAD>
             <BODY>
                 <H1>Statistics for <xsl:value-of select="sourcebin"/></H1>
                 <HR/>
                 <xsl:apply-templates select="overall"/>
                 <HR/>
                 <xsl:apply-templates select="hosts"/>
             </BODY>
             </HTML>
         </xsl:otherwise>
     </xsl:choose>
</xsl:template>

<xsl:template match="/bininfo/overall">
        <H3>Overall statistics (all hosts together)</H3>
        <TABLE BORDER="1" CELSPACING="0" CELPADDING="0">
        <TR><TD bgcolor="#CCDEFF">Message Name</TD><TD bgcolor="#CCDEFF">Min Time</TD>
            <TD bgcolor="#CCDEFF">Max Time</TD><TD bgcolor="#CCDEFF">Size in bytes</TD>
            <TD bgcolor="#CCDEFF">Messages</TD></TR>
            <xsl:apply-templates select="message_stat"/>
        </TABLE>
</xsl:template>

<xsl:template match="message_stat">
        <TR><TD bgcolor="#D4EBFF"><xsl:value-of select="messagename"/></TD>
            <TD bgcolor="#D4EBFF"><xsl:value-of select="mintime"/></TD>
            <TD bgcolor="#D4EBFF"><xsl:value-of select="maxtime"/></TD>
            <TD bgcolor="#D4EBFF"><xsl:value-of select="space"/> 
                (<xsl:value-of select="space_frac"/>%)</TD>
            <TD bgcolor="#D4EBFF"><xsl:value-of select="messages"/>
                (<xsl:value-of select="messages_frac"/>%)</TD>
        </TR>
</xsl:template>

<xsl:template match="/bininfo/hosts">
        <H3>Host statistics</H3>
        <xsl:apply-templates select="host_stat"/>
        Total: <xsl:value-of select="$total_hosts"/> different hosts.
</xsl:template>

<xsl:template match="/bininfo/hosts/host_stat">
        <H4><xsl:value-of select="hostname"/></H4>
        <TABLE BORDER="1" CELSPACING="0" CELPADDING="0">
        <TR><TD bgcolor="#CCDEFF">Message Name</TD><TD bgcolor="#CCDEFF">Min Time</TD>
            <TD bgcolor="#CCDEFF">Max Time</TD><TD bgcolor="#CCDEFF">Size in bytes</TD>
            <TD bgcolor="#CCDEFF">Messages</TD></TR>
            <xsl:apply-templates select="message_stat"/>
        </TABLE>
</xsl:template>

</xsl:stylesheet>
