<?

  include(Str_Replace("usersload.php","config.inc",__FILE__));
  include(Str_Replace("usersload.php","system.inc",__FILE__));

  /* create temporary output file */
  $tmpfname = tempnam ($tmpfiles_dir, "binselect_");

  $binselect_params = Array (
            "$binselect_executable",
	    "-C $binselect_config_file",
            "-S BinSelect.InputDatafile=$binstore.dat",
            "-S BinSelect.InputIndexfile=$binstore.idx",
            "-S BinSelect.OutputFile=$tmpfname",
            "-S BinSelect.StartTime=start",
            "-S BinSelect.EndTime=end",
            "-S BinSelect.MsgName=UptimeMessage",
            "-S BinSelect.Host=*",
            "-S BinSelect.AgentName=*",
            "-S BinSelect.Instance=*",
            "-S BinSelect.OutputAttributes=\"USERS LOAD1 LOAD5 LOAD15\"");

  $result = mysystem ($binselect_params, false);

  echo "<HTML><HEAD><TITLE>Load and Users</TITLE></HEAD><BODY>\n";

  if (count($result)>1 || (trim($result[0]) != ""))
  {
      @unlink($tmpfname);
      echo "<H5>Serious error when running binselect:</H5>\n";
      for ($i=0;$i<count($result);$i++)
         echo htmlentities ($result[$i]) ."<br>\n";
      die  ("</BODY></HTML>\n");
  }

  $lines = file ($tmpfname);

  echo "<H2>Average Load and Users</H2>\n";
  echo "<H5>". $lines[0] ."</H5>\n";

  $res = explode (" ", $lines[1]);
  $st_time = $res[0];
  $en_time = $res[1];

  $res = explode (" ", $lines[count($lines)-1]);
  $lines[count($lines)-1] = "";
  $st_time = $res[0]-1;
  $en_time = $res[1];

  $step = round(($en_time - $st_time) / 1200);
  $heart_beat = round(120 * $step);

  if ($step < 1)
      die("Not enough data for statistics!\n</BODY></HTML>\n");
      
  print "<!-- step = $step, st = $st_time, en = $en_time -->";

  $rrd_name = tempnam ($tmpfiles_dir, "rrd");
  $_opts = array( "-b", $st_time, "--step", $step,
                  "DS:USERS:GAUGE:$heart_beat:U:U",
                  "DS:L1:GAUGE:$heart_beat:U:U",
                  "DS:L5:GAUGE:$heart_beat:U:U",
                  "DS:L15:GAUGE:$heart_beat:U:U",
                  "RRA:AVERAGE:0.5:1:1200"
               );

  $ret = rrd_create($rrd_name, $_opts, count($_opts));

  if ($ret == 0 || !file_exists ($rrd_name))
  {
      $err = rrd_error();
      @unlink($tmpfname);
      die("Error creating rrd database: $err\n</BODY></HTML>\n");
  }
 
  for ($i=2;$i<count($lines)-1;$i++)
  {
        $comp = explode ( ":", $lines[$i] );
        $comp[2] /= 100;
        $comp[3] /= 100;
        $comp[4] /= 100;
        $lines[$i] = implode ( ":", $comp);
        
        $ret = rrd_update($rrd_name, $lines[$i] );

        if ($ret == 0)
        {
            @unlink($tmpfname);
            @unlink($rrd_name);
            $err = rrd_error();
            die ("Error while updating rrd database: ".
                 "$err\n</BODY></HTML>\n");
        }
  }

  @unlink($tmpfname);

  $_opts = array( "-s", $st_time, "-e", $en_time, "--title=\"Average Load\"", 
                  "DEF:l1=$rrd_name:L1:AVERAGE",
                  "DEF:l5=$rrd_name:L5:AVERAGE",
                  "DEF:l15=$rrd_name:L15:AVERAGE",
                  "LINE2:l1#00ff00:\"Load 1\"",
                  "LINE2:l5#ff0000:\"Load 5\"",
                  "LINE2:l15#0000ff:\"Load 15\"" );

  $load_name = tempnam ($tmpfiles_dir, "load");

  $ret = rrd_graph($load_name, $_opts, count($_opts));

  if (!is_array ($ret) || !file_exists ($load_name))
  {
        @unlink($rrd_name);
        @unlink($load_name);
        $err = rrd_error();
        die ("Error while generating load graph: $err\n</BODY></HTML>\n");
  }

  $l_name = "$base_path/$tmpfiles_dir/" .basename ($load_name). ".gif"; 
  if (@rename ($load_name, $l_name) == false)
  {
        @unlink($rrd_name);
        @unlink($load_name);
        echo "Can't create file: $l_name";
        die ("</BODY></HTML>\n");
  }

  $_opts = array( "-s", $st_time, "-e", $en_time, "--title=\"Users\"", 
                  "DEF:users=$rrd_name:USERS:AVERAGE",
                  "LINE2:users#0000ff:\"USERS\"" );

  $users_name = tempnam ($tmpfiles_dir, "users");
  
  $ret = rrd_graph($users_name, $_opts, count($_opts));

  if (!is_array ($ret) || !file_exists ($users_name))
  {
        @unlink($rrd_name);
        @unlink($load_name);
        @unlink($users_name);

        $err = rrd_error();
        die ("Error while generating users graph: $err\n</BODY></HTML>\n");
  }

  $u_name = "$base_path/$tmpfiles_dir/" .basename ($users_name). ".gif"; 
  if (@rename ($users_name, $u_name) == false)
  {
        @unlink($rrd_name);
        @unlink($load_name);
        @unlink($users_name);
        echo "Can't create file: $u_name";
        die ("</BODY></HTML>\n");
  }

  @unlink($rrd_name);
  @unlink($load_name);
  @unlink($users_name);

  echo "<H5>Logged on users: ". date("F j, Y, G:i:s", $st_time) . " - " .
                                date("F j, Y, G:i:s", $en_time) . "</H5>\n";
  echo "<img SRC=" .$base_url. "/". $users_name .".gif ALT=\"Logged on users\">\n";
  echo "<H5>Average load: ". date("F j, Y, G:i:s", $st_time) . " - " .
                                date("F j, Y, G:i:s", $en_time) . "</H5>\n";
  echo "<img SRC=" .$base_url. "/". $load_name .".gif ALT=\"Average load\">\n";
  echo "</BODY></HTML>\n";

?>
